//**********************************************************************
// Agat RT, Russia, Moscow, tel./fax +7(495)799-9069, +7(495)656-5492,  +7(495)656-5592
// Alder14t Driver Main Header File
// 12/08/2013 Version 10.2.2.2
//   Alder-14t
//**********************************************************************

#ifndef _ALDER14T_HEADER_
#define _ALDER14T_HEADER_

#ifdef __cplusplus
extern "C"
{
#endif

#define drvA14tDrvIdent						0xABF00000

// Tree VxD Driver fuctions
#define drvA14tGetVersion					drvA14tDrvIdent+ 0x00000010
#define drvA14tGetBoardType					drvA14tDrvIdent+ 0x00000020
#define drvA14tGetLastError					drvA14tDrvIdent+ 0x00000030

#define drvA14tOpenBoard					drvA14tDrvIdent+ 0x00000040
#define drvA14tCloseBoard					drvA14tDrvIdent+ 0x00000050
#define drvA14tStartBoards  				drvA14tDrvIdent+ 0x00000060
#define drvA14tStopBoards	  				drvA14tDrvIdent+ 0x00000070
#define drvA14tSetIrqFrequency				drvA14tDrvIdent+ 0x00000080
#define drvA14tGetLinesStatus 				drvA14tDrvIdent+ 0x00000090
#define drvA14tSetPhoneParams				drvA14tDrvIdent+ 0x000000A0
#define drvA14tPutVoiceData					drvA14tDrvIdent+ 0x000000B0
#define drvA14tSetVolume	   				drvA14tDrvIdent+ 0x000000C0
#define drvA14tRing							drvA14tDrvIdent+ 0x000000D0
#define drvA14tLock							drvA14tDrvIdent+ 0x000000E0
#define drvA14tSetPlayAGC					drvA14tDrvIdent+ 0x000000F0
#define drvA14tSetRecord	   				drvA14tDrvIdent+ 0x00000100
#define drvA14tGetVoiceData					drvA14tDrvIdent+ 0x00000110
#define drvA14tSetGain 	  					drvA14tDrvIdent+ 0x00000120
#define drvA14tSetRecordAGC					drvA14tDrvIdent+ 0x00000130
#define drvA14tSetVox						drvA14tDrvIdent+ 0x00000140
#define drvA14tGenerateTone					drvA14tDrvIdent+ 0x00000150
#define drvA14tGeneratePBXTone				drvA14tDrvIdent+ 0x00000160
#define drvA14tSetVadLevel					drvA14tDrvIdent+ 0x00000170
#define drvA14tSetAon						drvA14tDrvIdent+ 0x00000180
#define drvA14tSetEchocanceler				drvA14tDrvIdent+ 0x00000190
#define drvA14tSetLevelIndication			drvA14tDrvIdent+ 0x000001A0
#define drvA14tSetAccuParams				drvA14tDrvIdent+ 0x000001B0
#define drvA14tSetConnectionMode			drvA14tDrvIdent+ 0x000001C0
#define drvA14tSetHook						drvA14tDrvIdent+ 0x000001D0
#define drvA14tDial							drvA14tDrvIdent+ 0x000001E0
#define drvA14tSetPlayModeEx				drvA14tDrvIdent+ 0x000001F0
#define drvA14tSetSimplexSwitch				drvA14tDrvIdent+ 0x00000200
#define drvA14tSetNoiseVolume				drvA14tDrvIdent+ 0x00000210
#define drvA14tPutNoiseBlocks				drvA14tDrvIdent+ 0x00000220		// Empty

#define drvA14tGetPciBoardAmount			drvA14tDrvIdent+ 0x00000230
#define drvA14tGetPciBoardInfo				drvA14tDrvIdent+ 0x00000240

// E1 routins
#define drvA14tSetE1RawMode					drvA14tDrvIdent+ 0x00000250		//For E1 lines only
#define drvA14tGetE1Status					drvA14tDrvIdent+ 0x00000260		//For E1 lines only
#define drvA14tGetE1RawData					drvA14tDrvIdent+ 0x00000270		//For E1 lines only
#define drvA14tPutE1RawData					drvA14tDrvIdent+ 0x00000280		//For E1 lines only

// E1 params routins
#define drvA14tSetE1SynchroType				drvA14tDrvIdent+ 0x00000290		//For E1 lines only
#define drvA14tSetE1LinearCode				drvA14tDrvIdent+ 0x000002A0		//For E1 lines only
#define drvA14tGetE1HardwareProperties 		drvA14tDrvIdent+ 0x000002B0		//For E1 lines only
#define drvA14tSetE1ConnectionType			drvA14tDrvIdent+ 0x000002C0		//Empty
#define drvA14tSetE1DTEMode					drvA14tDrvIdent+ 0x000002D0		//For E1 lines only
#define drvA14tSetE1VoiceSynchro			drvA14tDrvIdent+ 0x000002E0		//For E1 lines only

#define drvA14tSetLineType					drvA14tDrvIdent+ 0x000002F0		//Empty
#define drvA14tSetE1ToneDetector			drvA14tDrvIdent+ 0x00000300		//Empty
#define drvA14tSetToneDetector				drvA14tDrvIdent+ 0x00000300
#define drvA14tE1ToneGenerator				drvA14tDrvIdent+ 0x00000310		//For E1 lines only

#define drvA14tSetConference				drvA14tDrvIdent+ 0x00000320
#define drvA14tSetSimplexSwitchEx			drvA14tDrvIdent+ 0x00000330
#define drvA14tSetDTMFFiltering				drvA14tDrvIdent+ 0x00000340
#define drvA14tSetNoiseCanceler				drvA14tDrvIdent+ 0x00000350
#define drvA14tSetPolarityReversal			drvA14tDrvIdent+ 0x00000360
#define drvA14tOpenIsdnBoard				drvA14tDrvIdent+ 0x00000370		//Empty
#define drvA14tSetE1DialMode				drvA14tDrvIdent+ 0x00000380
#define drvA14tSetE1CalledNumberParams 		drvA14tDrvIdent+ 0x00000390		//Empty
#define drvA14tSetE1CallerNumberParams 		drvA14tDrvIdent+ 0x000003A0		//Empty
#define drvA14tSetE1MFRParams 				drvA14tDrvIdent+ 0x000003B0		//Empty
#define drvA14tSetE1OverlapTimeOutParams	drvA14tDrvIdent+ 0x000003C0		//Empty
#define drvA14tGetBoardProperties			drvA14tDrvIdent+ 0x000003D0
#define drvA14tIsPnPDriver					drvA14tDrvIdent+ 0x000003E0
#define drvA14tFlash						drvA14tDrvIdent+ 0x000003F0
#define drvA14tSetLineBreakParams			drvA14tDrvIdent+ 0x00000400
#define drvA14tSetDTMFDialLevel				drvA14tDrvIdent+ 0x00000410
#define drvA14tSetPBXToneLevel				drvA14tDrvIdent+ 0x00000420
#define drvA14tSetToneLevel					drvA14tDrvIdent+ 0x00000430
#define drvA14tSetDTMFDetectorSensibility	drvA14tDrvIdent+ 0x00000440
#define drvA14tSetGainMode 					drvA14tDrvIdent+ 0x00000450		//Empty
#define drvA14tSetDTMFDetectorMode			drvA14tDrvIdent+ 0x00000460		//Empty
#define drvA14tSetE1AlertingDelay			drvA14tDrvIdent+ 0x00000470		//Empty
#define drvA14tSendE1Command				drvA14tDrvIdent+ 0x00000480		//Empty
#define drvA14tSetEdss1Params				drvA14tDrvIdent+ 0x00000490		
#define drvA14tSetSs7Params					drvA14tDrvIdent+ 0x000004A0

#define drvA14tH100SetBoardParameters		drvA14tDrvIdent+ 0x000004B0
#define drvA14tH100SetCommutation			drvA14tDrvIdent+ 0x000004C0
#define drvA14tISDNMCommand					drvA14tDrvIdent+ 0x000004D0
#define drvA14tSetDirectSimplex				drvA14tDrvIdent+ 0x000004E0

#define drvA14tLinkLineToProcess			drvA14tDrvIdent+ 0x00000600
#define drvA14tSetE1Properties				drvA14tDrvIdent+ 0x00000610
#define drvA14tSetE1Alerting				drvA14tDrvIdent+ 0x00000620
#define drvA14tSetFXSParameters				drvA14tDrvIdent+ 0x00000630
#define drvA14tSetFXOParameters				drvA14tDrvIdent+ 0x00000640
#define drvA14tH100SetLineProperties		drvA14tDrvIdent+ 0x00000650
#define drvA14tH100SetInterfaceProperties	drvA14tDrvIdent+ 0x00000660
#define drvA14tE1Answer						drvA14tDrvIdent+ 0x00000670
#define drvA14tSetE1LineProperties			drvA14tDrvIdent+ 0x00000680
#define drvA14tE1Restart					drvA14tDrvIdent+ 0x00000690

// Alder Board RecordMode
#ifndef drvNoRecord
#define	drvNoRecord					0
#endif

#ifndef drvGsmRecord
#define	drvGsmRecord				1	// GSM with Motorola bit sequence
#endif

#ifndef drvMuLawRecord
#define	drvMuLawRecord				2	// G711 (CCITT MuLaw)
#endif 

#ifndef drvALawRecord
#define	drvALawRecord				3	// G711 (CCITT A-Law)
#endif

#ifndef	drvPcmRecord
#define	drvPcmRecord				4	// Pulse coding modulation
#endif

#ifndef	drvMsGsmRecord
#define	drvMsGsmRecord				5	// Microsoft GSM (PC bit sequence)
#endif

#ifndef	drvG729Record
#define	drvG729Record				6	// G729
#endif

#ifndef	drvMpmlqRecord
#define	drvMpmlqRecord				7	// G723.1 MPMLQ
#endif

#ifndef	drvAcelpRecord
#define drvAcelpRecord				8	// G723.1 ACELP
#endif

#ifndef	drvRxFaxRecord
#define drvRxFaxRecord				17	// Fax receiver
#endif

#ifndef	drvTxFaxRecord
#define drvTxFaxRecord				18	// Fax transmitter
#endif

#ifndef exPlayOrdinary
#define exPlayOrdinary				0
#endif

#ifndef	exPlayUniform
#define exPlayUniform				1
#endif

#ifndef	exPlayCancelOperation
#define exPlayCancelOperation		2
#endif

#ifndef	PciBoard
#define PciBoard					0x02
#endif

// Alder Board Type
#ifndef	Alder14tBoard
#define Alder14tBoard				0xA1
#endif

#ifndef	Alder15tBoard
#define Alder15tBoard				0xA2
#endif

#ifndef	Alder14pBoard
#define Alder14pBoard				0xA3
#endif

#ifndef	Alder14mtBoard
#define Alder14mtBoard				0xA4
#endif

#ifndef	Alder14lpxBoard
#define Alder14lpxBoard				0xA5
#endif

#ifndef	Alder14lpeBoard
#define Alder14lpeBoard				0xA6
#endif

#ifndef	AlderMaxAttics			
#define AlderMaxAttics				16
#endif

// E1 Attic type
#ifndef	AtticE1Terminal60
#define AtticE1Terminal60			0x84
#endif
#ifndef	AtticE1Terminal30
#define AtticE1Terminal30			0x86
#endif
#ifndef AtticE1Monitor30
#define AtticE1Monitor30			0x87	
#endif

// E1 STS
#define AlderE1R15STS				0x10
#define AlderE1R2STS				0x20
#define AlderE1EDSS1STS				0x30
#define AlderE1QSIGSTS				0x40
#define AlderE1V5STS				0x50
#define AlderE1OKS7STS				0x70

// Alder Line LineType
#ifndef	AlderFullPhoneLine
#define AlderFullPhoneLine			0
#endif
#ifndef	AlderAccuLine
#define AlderAccuLine				1
#endif
#ifndef	AlderSafePhoneLine
#define AlderSafePhoneLine			2
#endif
#ifndef	AlderAbonentPhoneLine
#define AlderAbonentPhoneLine		3
#endif
#ifndef	AlderE1Line
#define AlderE1Line					4
#endif
#ifndef	AlderE1MonitoringLine
#define AlderE1MonitoringLine		5
#endif
#ifndef	AlderIsdnMonitoringLine
#define AlderIsdnMonitoringLine		6
#endif
#ifndef	AlderH100Line
#define AlderH100Line				7
#endif

// Alder Driver Line Status
#ifndef	drvAlderLineHook
#define drvAlderLineHook           	0x00000001
#endif
#ifndef	drvAlderLineAccu
#define drvAlderLineAccu           	0x00000002
#endif
#ifndef	drvAlderLineLevel          	
#define drvAlderLineLevel          	0x00000004
#endif
#ifndef	drvAlderLineRing
#define drvAlderLineRing			0x00000008
#endif
#ifndef	drvAlderLineOutgoing
#define drvAlderLineOutgoing		0x00000010
#endif
#ifndef	drvAlderLineIncoming
#define drvAlderLineIncoming		0x00000020
#endif
#ifndef	drvAlderLineNoDialTone
#define drvAlderLineNoDialTone		0x00000040
#endif
#ifndef	drvAlderLineDialTone
#define drvAlderLineDialTone		0x00000080
#endif
#ifndef	drvAlderLineBackRing
#define drvAlderLineBackRing		0x00000100
#endif
#ifndef	drvAlderLineBusy
#define drvAlderLineBusy			0x00000200
#endif
#ifndef	drvAlderLineDefined
#define drvAlderLineDefined			0x00000400	
#endif
#ifndef	drvAlderLineCallerID
#define drvAlderLineCallerID		0x00000400	// For E1 lines only
#endif
#ifndef	drvAlderLinePulseNum
#define drvAlderLinePulseNum		0x00000800
#endif
#ifndef	drvAlderLineCalledID
#define drvAlderLineCalledID		0x00000800	// For E1 lines only
#endif
#ifndef	drvAlderLineToneNum	
#define drvAlderLineToneNum			0x00001000
#endif
#ifndef	drvAlderLineNumDialed
#define drvAlderLineNumDialed		0x00002000
#endif
#ifndef	drvAlderLineRecord
#define drvAlderLineRecord			0x00004000
#endif
#ifndef	drvAlderLinePlayed
#define drvAlderLinePlayed			0x00008000
#endif
#ifndef	drvAlderLineInNumFault
#define drvAlderLineInNumFault		0x00010000
#endif
#ifndef	drvAlderLineInVox
#define drvAlderLineInVox			0x00020000
#endif
#ifndef	drvAlderLineVAD
#define drvAlderLineVAD				0x00080000
#endif
#ifndef	drvAlderLineToneNumDialed
#define drvAlderLineToneNumDialed	0x00100000
#endif
#ifndef	drvAlderLineFAX
#define drvAlderLineFAX				0x00200000
#endif
#ifndef	drvAlderLineConnect
#define drvAlderLineConnect			0x00400000
#endif
#ifndef	drvAlderLineFlash
#define drvAlderLineFlash			0x00800000
#endif
#ifndef	drvAlderLineLocked
#define drvAlderLineLocked			0x01000000
#endif
#ifndef	drvAlderLineNoSynchro
#define drvAlderLineNoSynchro		0x02000000	// For E1 lines only
#endif
#ifndef	drvAlderLineEndPlay
#define drvAlderLineEndPlay			0x04000000	// 
#endif
#ifndef	drvAlderLinePolarity
#define drvAlderLinePolarity		0x08000000	// Polarity reversal for FXOM line only
#endif
#ifndef	drvAlderLineRelease
#define drvAlderLineRelease			0x10000000	// For E1 line only
#endif
#ifndef	drvAlderLineBreak
#define drvAlderLineBreak			0x20000000	// For FXOM line only
#endif
#ifndef	drvAlderLineRestart
#define drvAlderLineRestart			0x20000000	// For E1 line only
#endif
#ifndef	drvAlderLineTSReady
#define drvAlderLineTSReady			0x40000000	// For E1 line only
#endif
#ifndef	drvAlderBoardError
#define drvAlderBoardError			0x80000000
#endif

#ifndef	PBXNOTONE
#define PBXNOTONE					0
#endif
#ifndef	PBXDIALTONE
#define PBXDIALTONE					1
#endif
#ifndef	PBXBACKRING
#define PBXBACKRING					2
#endif
#ifndef	PBXBUSY
#define PBXBUSY						3
#endif

#ifndef	_AlderEventsPredefine_
// Queued events from board
#define _AlderEventsPredefine_

#define drvAlderEventHookOff		1	// +0
#define drvAlderEventAccuOn			2	// +0
#define drvAlderEventAccuOff		3	// +0
#define drvAlderEventLevel			4	// +0  dwParam1= dwLevel
#define drvAlderEventRing			5	// +0  dwParam1= dwRingCount
#define drvAlderEventOutgoing		6	// +0 
#define drvAlderEventIncoming		7	// +0
#define drvAlderEventNoDialTone		8	// +0
#define drvAlderEventDialTone		9	// +0
#define drvAlderEventBackRing		10	// +0
#define drvAlderEventBusy			11	// +0
#define drvAlderEventAONNumber		12	// + TAlderEventNumberEx ( pszNumber & pszQuality)
#define drvAlderEventFSKNumber		13	// + TAlderEventNumberEx ( pszNumber & pszDateAndTime & pszUser)
#define drvAlderEventOriginNumber	14	// + TAlderEventNumber (pszNumber)
#define drvAlderEventDestNumber		15	// + TAlderEventNumber (pszNumber)
#define drvAlderEventPulseDigit		16	// dwParam1= dwDigit in ASCII code, + TAlderEventNumber (pszNumber)
#define drvAlderEventToneDigit		17	// dwParam1= dwDigit in ASCII code, + TAlderEventNumber (pszNumber)
#define drvAlderEventPulseDialed	18	// +0
#define drvAlderEventRecordData		19	// +0 dwParam1= dwRecordedWordsInLineBuffer
#define drvAlderEventPlayedData		20	// +0 dwParam1= dwUnplayedWordsInLineBuffer
#define drvAlderEventOriginFault	21	// +0
#define drvAlderEventInVOX			22	// +0 dwParam1= dwVoxCount in current Vox Session
#define drvAlderEventVAD			23	// +0
#define drvAlderEventToneDialed		24	// +0 
#define drvAlderEventFax			25	// +0
#define drvAlderEventConnect		26	// +0
#define drvAlderEventFlash			27	// +0
#define drvAlderEventLocked			28	// +0
#define drvAlderEventUnlocked		29	// +0
#define drvAlderEventE1Synchro		30	// +0 dwParam1= SyncState, dwParam2= D-channel State
#define drvAlderEventEndPlay		31	// +0
#define drvAlderEventPolarity		32	// +0
#define drvAlderEventRelease		33	// +0
#define drvAlderEventLineBreak		34	// +0
#define drvAlderEventTSReady		35	// +0
#define drvAlderEventRestart		36	// +0 dwParam1= Restart result
#define drvAlderEventError			256	// +TAlderEventError

typedef struct _tagTAlderEvent
{
	DWORD dwSizeInBytes;
	DWORD dwMedia;					// Always = 0xADEF
	LARGE_INTEGER qwDateAndTime;	// Date and Time by kernel
	DWORD dwType;					// Event type	
	DWORD dwHandle;					// Device handle
	DWORD dwAttic;					// Attic number for E1 lines
	DWORD dwLine;					// Line Number
	DWORD dwParam1;
	DWORD dwParam2;
} TAlderEvent;						// Total Size 10 dword

typedef struct _tagTAlderEventNumber
{
	char pszNumber[128];
}TAlderEventNumber;

typedef struct _tagTAlderEventNumberEx
{
	char pszNumber[32];
	char pszQuality[32];
	char pszDateAndTime[8];
	char pszUserName[16];
}TAlderEventNumberEx;

typedef struct _tagTAlderEventError
{
	DWORD dwDebug;
	DWORD dwPack;
	DWORD dwError;
}TAlderEventError;

#endif

// Only for E1 lines
#ifndef	PBXBUSYOVERLOAD
#define PBXBUSYOVERLOAD				4
#endif
#ifndef	PBXPOINTTONE
#define PBXPOINTTONE				5
#endif
#ifndef	PBXECHOCANCELERNEUTRICE
#define PBXECHOCANCELERNEUTRICE		6
#endif
#ifndef	PBXAONREQUEST
#define PBXAONREQUEST				7
#endif
#ifndef	PBXFAXREQUEST
#define PBXFAXREQUEST				8
#endif

#ifndef	A9MaxDigitChars
#define A9MaxDigitChars				128
#endif

#ifndef	A14tMaxDigitChars
#define A14tMaxDigitChars			128
#endif

#pragma pack(4)
typedef struct _tagDriverVersion
{	
	DWORD	dwMajor;
	DWORD	dwMinor;
	DWORD	dwLoader;
} DriverVersion;

typedef struct _tagDriverVersionEx
{	
	DWORD	dwMajor;
	DWORD	dwMinor;
	DWORD	dwBuild;
	DWORD	dwCompilation;
} DriverVersionEx;

// Data structures for Open Isa board
#define ResNoCompression			0x00
#define ResNoCompressionPlusEcho	0x01
#define ResCompression				0x02
#define ResCompressionPlusEcho		0x03
#define ResExtCompressionPlusEcho	0x04

typedef struct _tagPciBoardData
{	
	DWORD	dwBoardType;
	DWORD	dwBasePort;
	DWORD	dwCtrlPort;
	DWORD	dwIrq;
	DWORD	dwBusNumber;
} PciBoardData;

// Input data structure
typedef struct _tagBoardLoadData
{ 
	DWORD 	dwBasePort;
	BYTE	*lpbLoader;
	DWORD	dwLoadSize;
} BoardLoadData;

// Input data structure
typedef struct _tagBoardLoadDataEx
{ 
	DWORD dwBasePort;
	BYTE *lpbLoader;
	DWORD dwLoadSize;
	DWORD dwNeedSCBus;				// != 0 - Load SPARTAN for SC-Bus, 0 = ignore SC-Bus
	DWORD dwNeedSDRAMTest;			// != 0 - SDRAMtest enable ( 20 sec approximatly), = 0 no test, quick start
	DWORD dwNoResetAfterClose;		// != 0 - Not teset board after close, = 0 Reset after close ( by default)
	DWORD dwNoCalcResourceWeight;	// != 0 - Not calculate resource weight for defend device overload
	DWORD dwSCBusTerminator;		// != 0 - SCBus terminator ON after device initialization
	DWORD dwA15tProperties;			// Tms type selector for a15t ( 0 - 6713, != 0 - 6412)
	DWORD dwH100SetupManual;		// != 0 - driver do not setup H100 chip
	DWORD dwH100LinesEnable;		// != 0 enable work with H100 virual lines
	DWORD dwReserved[25];
} BoardLoadDataEx;

// Output data structure
typedef struct _tagBoardInfo
{	
	DWORD 	dwBoardHandle;
	DWORD 	dwFactoryNumber;
	DWORD	dwLoaderVersion;
	DWORD	dwE1MajorVersion;
	DWORD	dwE1MinorVersion;
	DWORD	dwResourceMode;
	DWORD	dwLines;
	DWORD	dwVoiceLines;
	BYTE	lpbLinesTypes[256];
} BoardInfo;

// Data structure for Set IRQ frequency
typedef struct _tagIrqFrequencyData
{
	DWORD 	dwBoardHandle;
	DWORD 	dwIrqFrequency;
} IrqFrequencyData;

// Data structure for Get Line(s) status
typedef struct _tagLinesStatusParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwBeginLine;
	DWORD	dwAmountLines;
} LinesStatusParams;

// Data structure for Set Phone line parameters
typedef struct _tagPhoneLineParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwHookLevel;
	DWORD 	dwRingLevel;
} PhoneLineParams;

// Data structure for Set Phone line parameters
typedef struct _tagPutVoiceParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwPlayMode;
	BYTE	*lpbVoicePtr;
	DWORD 	dwLength;
} PutVoiceParams;

typedef struct _tagVolumeParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwVolume;
} VolumeParams;

typedef struct _tagRingParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} RingParams;

#define _CallerID_SMDF_Type_	1	// Simple mode transfer data packet
#define _CallerID_MDMF_Type_	2   // Extended mode transfer data packet

#define _CallerID_OutOfArea_	1	
#define _CallerID_PrivateInfo_	2	

typedef struct _tagRingParamsEx
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	// CallerID info for FXS lines
	DWORD	dwCallerIDMode;			// _CallerID_SMDF_Type_ or _CallerID_MDMF_Type_
	char	lpbMonth[2];			// ASCII digits
	char	lpbDay[2];				// ASCII digits
	char	lpbHours[2];			// ASCII digits
	char	lpbMinuts[2];			// ASCII digits
	char	pszNumber[32];			// ASCII digits, ASCIIZ stirng
	DWORD	dwNumberAbsentCause;	// _CallerID_OutOfArea_ or _CallerID_PrivateInfo_
	char	pszUserName[16];		// ASCII digits, ASCIIZ stirng
	DWORD	dwUserNameAbsentCause;	// _CallerID_OutOfArea_ or _CallerID_PrivateInfo_
} RingParamsEx;

typedef struct _tagLockParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} LockParams;

typedef struct _tagAgcParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwDynamic;
	DWORD	dwTime;
	DWORD	dwNoiseLevel;
	DWORD	dwMode;			// AGC record mode 0 or 1 ( 0 by default)
} AgcParams;

typedef struct _tagRecordParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} RecordParams;

typedef struct _tagGetVoiceParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
} GetVoiceParams;

typedef struct _tagGainParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwGain;
} GainParams;

typedef struct _tagVoxParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	DWORD	dwLevel;
	DWORD 	dwTime;
} VoxParams;

typedef struct _tagGenerateToneParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwFrequency;
} GenerateToneParams;

typedef struct _tagPBXToneParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwPBXTone;
	DWORD	dwPBXFreqIndex;			// new!!! 0- 425 Hz 1 - 460 Hz
} PBXToneParams;

typedef struct _tagVADParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwLevel;
} VADParams;

typedef struct _tagAONParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	DWORD	dwLevel;
	DWORD	dwDelayTime;
	DWORD	dwDuration;
	DWORD 	dwRequests;
} AONParams;

typedef struct _tagEchocancelerParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwEchoMode;
	DWORD	dwRestEchoMode;
} EchocancelerParams;

typedef EchocancelerParams TEchocancelerParams;

typedef struct _tagTEchocancelerParamsEx
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwEchoMode;
	DWORD	dwRestEchoMode;
	DWORD	dwNlpSensLevel;	//     (0,96dB,  1dB, 9dB  )
	int		iNoiseVolume;	//  ,      (-96,96 dB,  1 dB, -45 dB  )
	DWORD	dwNoiseType;	//  ,      (0 - , 1 -  , 2 -   )
} TEchocancelerParamsEx;

typedef struct _tagLevelIndicationParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} LevelIndicationParams;

typedef struct _tagAccuParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	DWORD	dwLevel;
	DWORD	dwTime;
} AccuParams;

typedef struct _tagConnectionParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} ConnectionParams;

typedef struct _tagHookParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} HookParams;

typedef struct _tagHookParamsEx
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	DWORD	dwReleaseCause;			// by Q.931
} HookParamsEx;

typedef struct _tagFlashParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwFlashTime;		// 0-15 ( mlsec= dwFlashTime*100)
} FlashParams;

// For E1 lines only!
#define NoHardwareType		0
#define VoiceHardwareType	1
#define FaxHardwareType		4

typedef struct _tagDialParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	char	pszNumber[128];
	char	pszCallerID[32];	// Caller ID, only for E1 line
	DWORD	dwHardwareType;		// 0- nothing, 1- phone, 2- fax 
} DialParams;

typedef struct _tagDialParamsEx
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	char	pszNumber[128];
	char	pszCallerID[32];	// Caller ID, only for E1 line
	DWORD	dwHardwareType;		// ignore
	DWORD	dwCategory;			// For SS7 CALLING_PARTY_CATEGORY 0-254
	DWORD	dwNoRestriction;	// ignore
	DWORD	dwReserved[19];
} DialParamsEx;

typedef struct _tagPlayExParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	DWORD	dwPlayBufSize;
} PlayExParams;

typedef struct _tagSimplexSwitchParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwMode;				// 0- disconnect, != 0 connect
	DWORD 	dwSrcLine;			// Source line for output samples
	DWORD	dwDstLine;			// Destination line for input samples
	DWORD	dwVolume;			// Summ mode == 0 record simplex source signal on SrcLine, 
								// != 0 record summ duplex signals on DstLine
} SimplexSwitchParams;

typedef struct _tagNoiseParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwVolume;
} NoiseParams;

typedef struct _tagNoiseBlocksParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwAmount;
	DWORD	dwVolume;
} NoiseBlocksParams;

// Data structire for E1 routins
typedef struct _tagE1RawParams
{
	DWORD dwBoardHandle;
	DWORD dwMode;
} E1RawParams;

// For E1 line data structures
typedef struct _tagE1HardwareProperties
{
	DWORD dwE1DeviceAmount;
	DWORD dwE1DeviceType[2];
	DWORD dwE1LinesAmount[2];
} E1HardwareProperties;


#define _A14T_E1_GET_PROTO( lpdwMsg)	( lpdwMsg[0]&0x0000FF00)
#define _A14T_E1_GET_LENGTH( lpdwMsg)	( lpdwMsg[0]&0x000000FF)
#define _A14T_E1_GET_LINE( lpdwMsg)		( lpdwMsg[0]>>16)
#define _A14T_E1_GET_MSG_TYPE( lpdwMsg)	( lpdwMsg[1]&0xFF000000)

#define PROTO_E1_CCP					0x00000100
#define PROTO_E1_LINE					0x00000200
#define PROTO_E1_MONITOR				0x00000500
#define PROTO_E1_MANUAL_SETTINGS		0x00000600

#define _E1_LINE_INIT_					0x01000000
#define _E1_LINE_EDSS_PARAM_			0x08000000
#define _E1_LINE_SS7_PARAM_				0x09000000
#define _E1_LINE_SET_STS_				0x0B000000
#define _E1_LINE_INIT_EX_				0x0D000000
#define _E1_LINE_INIT_CHANGE_BLOCKING_	0x12000000

#define _lineIECode_HAUL_PARAM_			1
#define _lineIECode_CHANGE_BLOCKING_    16

#define _E1_CCP_SETUP					0x05000000
#define _E1_CCP_SETUP_ACK				0x0D000000
#define _E1_CCP_ALERTING				0x01000000
#define _E1_CCP_CONNECT					0x07000000
#define _E1_CCP_RESTART					0x46000000
#define _E1_CCP_RELEASE					0x4D000000
#define _E1_CCP_RESTART_ACK				0x4E000000
#define _E1_CCP_RELEASE_COMP			0x5A000000
#define _E1_CCP_INFORM					0x7B000000

#define _E1_INFO_DEST_NUM				0x01
#define _E1_INFO_ORIG_NUM				0x02
#define _E1_INFO_DISCONNECT_CAUSE		0x03
#define _E1_INFO_SEND_COMPLETE			0x12
#define _E1_INFO_RESTART				0x18
#define _E1_INFO_TIME_SLOT				0x19
#define _E1_INFO_PROGRESS_INDICATOR		0x20
#define _E1_CALLING_PARTY_CATEGORY_		0x21

#define _E1_LINE_SETUP_NOP				0
#define _E1_LINE_SETUP_AMI				1
#define _E1_LINE_SETUP_HDB3				2

#define _E1_LINE_SETUP_CRC4_OFF			1
#define _E1_LINE_SETUP_DOUBLE_FRAME		1
#define _E1_LINE_SETUP_CRC4_ON			2
#define _E1_LINE_SETUP_MULTI_FRAME		2

#define _E1_LINE_SETUP_INTERNAL_SYNC	1
#define _E1_LINE_SETUP_EXTERNAL_SYNC	2

#define _E1_LINE_ACK_SYNC_OK			0x02000000
#define _E1_LINE_ACK_SYNC_LOST			0x03000000

#define _E1_LINE_SETUP_EDSS1_MASTER		1
#define _E1_LINE_SETUP_EDSS1_NET		1
#define _E1_LINE_SETUP_EDSS1_SLAVE		2
#define _E1_LINE_SETUP_EDSS1_USER		2

#define _E1_LINE_ACK_EDSS1_D_SYNC_OK	0x04000000
#define _E1_LINE_ACK_EDSS1_D_SYNC_LOST	0x05000000


#define drvAlderE1RawDataReady			0x00000001
#define drvAlderE1SynchroInfo 			0x00000002
#define drvAlderE1DStateInfo 			0x00000004
#define drvAlderE1RestartComplete0		0x00000010	//  0  1 
#define drvAlderE1RestartError0			0x00000020	//  0  1 
#define drvAlderE1RestartComplete1		0x00000030	//  1  1 
#define drvAlderE1RestartError1			0x00000080	//  1  1 

#define E1SynchroEstablished			0
#define E1ZeroReceive					1
#define E1AIS							2
#define E1CarrierLost					3
#define E1RemoteAlarm					4

#define E1DStateAwaitEstablish			0
#define E1DStateMultiFrame				1
#define E1DStateTimerRecovery			2
#define E1DStateError					3

typedef struct _tagE1Status
{
	DWORD	dwChanged;
	DWORD 	dwSynchroInfo[2];
	DWORD   dwDStateInfo[2];
	DWORD	dwDataReadyAmount;
} E1Status;

typedef struct _tagE1StatusParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
} E1StatusParams;

typedef struct _tagE1GetRawDataParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
} E1GetRawDataParams;

typedef struct _tagE1PutRawDataParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	WORD  *lpwRawData;
	DWORD dwLen;	
} E1PutRawDataParams;

// Data structure for E1 synchro type setup
#define E1SynchroDoubleFrame	0	// default
#define E1SynchroMultiFrame		1

typedef struct _tagE1SynchroParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwSynchroType;
} E1SynchroParams;

// Data structure for E1 linear code type setup
#define E1LinearCodeHDB3		0	// Default
#define E1LinearCodeAMI			1

typedef struct _tagE1LinearCodeParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwCodeType;
} E1LinearCodeParams;

#define E1UserUserConnection	0	// Default
#define E1NetUserConnection		1
#define E1UserNetConnection		2
#define E1NetNetConnection		3

typedef struct _tagE1ConnectionTypeParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwConnectionType;
} E1ConnectionTypeParams;

#define E1DTESlave				0
#define E1DTEMaster				1

typedef struct _tagE1DTEModeParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwDTEMode;
} E1DTEModeParams;

typedef struct _tagTEdss1Params
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwDTEMode;				// 0 - Slave, 1 - Master
	DWORD dwCallingNumberType;		// 0 - *Unknown, 1 - International, 2 - National, 3 - Network, 4 - Subscriber, 6 - Abbreviated
	DWORD dwCallingScreenIndicator;	// 0 - *NScreened, 1 - VerifyPass, 2 - VerifyFail, 3 - Network
	DWORD dwCallingPresentIndicator;// 0 - Allowed, 1 - *Restricted, 2 - NotAviable
	DWORD dwCalledNumberType;		// 0 - *Unknown, 1 - International, 2 - National, 3 - Network, 4 - Subscriber, 6 - Abbreviated
	DWORD dwT302Time;				// 1 - 59 (15- by default)
	DWORD dwManualAlerting;			// != 0 Driver do not sent ALERTING automatically
	DWORD dwProgressIndicator;		// != 0 Device sent PI after SETUP receive, 1 and 8 value recommended by Q.931
	DWORD dwReserved[5];			// Reserved
} TEdss1Params;

typedef struct _tagTSS7Params
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwOPC;			// Originator Point code ( 1 - by default, 0-99999)
	DWORD dwDPC;			// Destination Point code ( 2 - by default, 0-99999)
	DWORD dwNetType;		// Network Indicator ( 2 - by default, 0-3)
	DWORD dwLink;			// Signaling link code ( 0 - by default, 0-15)
	DWORD dwHighCIC;		// High bits of Circuit Identification code ( 0 - by default, 0-127)
	DWORD dwKindPrior;		// ( 1- by default, 0-4)
	DWORD dwDefCategory;	// Calling party's category ( 10-by default, 0-254)
	DWORD dwMediaRequest;	// ( 3- by default, 0-99)
	DWORD dwForwardInd;		// Forward call indicators ( 96-by default, 0-9999)
	DWORD dwBackwardInd;	// Backward call indicators ( 1040-by default, 0-9999)
	DWORD dwSubscrAddrPlan;	// Numbering plan indicator ( 1-by default, 0-9)
	DWORD dwSubscrAddrINN;	// Internal Network number indicator ( 0-by default, 0-9)
	DWORD dwSubscrAddrAPRI;	// Address presentation restricted indicator ( 0-by default, 0-9)
	DWORD dwSubscrAddrScreen; // Screening indicator ( 1-by default, 0-9)
} TSS7Params;

#define E1VoiceSynchroByBoard	0	// default
#define E1VoiceSynchroByStream	1	// synchro by E1 stream

typedef struct _tagE1VoiceSynchroParams
{
	DWORD dwBoardHandle;
	DWORD dwMode;
	DWORD dwE1Device;
	DWORD dwE1Line;
} E1VoiceSynchroParams;

#define E1LineUniversal			0	// by default
#define E1LineIncoming			1	// Only incoming seance
#define E1LineOutgoing			2	// Only outgoing seance

typedef struct _tagLineTypeParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwType;
} LineTypeParams;

#define E1TonalDetectorOff		1
#define E1TonalDetectorDTMF		3
#define E1TonalDetectorMFC1		4
#define E1TonalDetectorMFC2		5
#define E1TonalDetectorMFS		6
#define E1TonalDetectorAON		7

typedef struct _tagE1ToneDetectorParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwMode;
} E1ToneDetectorParams;

// Tone set for tone sinals (Tonal generator mode)
#define E1TonalGeneratorDTMF	0
#define E1TonalGeneratorMFC1	1
#define E1TonalGeneratorMFC2	2
#define E1TonalGeneratorMFS		3
#define E1TonalGeneratorAON		4

typedef struct _tagE1ToneGeneratorParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwMode;			// Tone set for tone sinals
	DWORD dwDuration;		// Tone signal duration
	DWORD dwPause;			// Pause duration between signals
	char  pszNum[16];		// Digits for tone generation ( 8 maximum)
} E1ToneGeneratorParams;

typedef struct _tagConferenceParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwConferenceId;	// 0-29 not more!
	DWORD dwMode;			// 0 - exclude line from conference, 
							// 1 - include line in conference
							// 2 - reset conference (exclude all lines form conf.) 
} ConferenceParams;

typedef struct _tagSimplexSwitchParamsEx
{
	DWORD 	dwDstBoardHandle; 	// Target Board for input SCbus samples
	DWORD	dwDstLine;			// Target line for input SCbus samples
	DWORD 	dwSrcBoardHandle;	// Source Board samples generator
	DWORD 	dwSrcLine;			// Src Line samples 
	DWORD 	dwMode;				// 0- disconnect, != 0 connect
	DWORD	dwVolume;			// Summ record mode
} SimplexSwitchParamsEx;

typedef struct _tagDTMFFilteringParams
{
	DWORD 	dwBoardHandle; 		// Target Board 
	DWORD	dwLine;				// Target line 
	DWORD 	dwMode;				// 0- disable, != 0 enable
} DTMFFilteringParams;

typedef struct _tagDTMFDetectorParams
{
	DWORD 	dwBoardHandle; 		// Target Board 
	DWORD	dwLine;				// Target line 
	DWORD 	dwMode;				// 0- disable, != 0 enable
} DTMFDetectorParams;

#define PolarityDisable		0
#define PolarityEnable		1
#define PolarityRequest		2

typedef struct _tagNoiseCancelerParams
{
	DWORD 	dwBoardHandle; 		// Target Board 
	DWORD	dwLine;				// Target line 
	DWORD 	dwNoiseLevel;		// <= 15
	DWORD	dwTimeConstant;		// Time constant for noisecanceler
} NoiseCancelerParams;

typedef struct _tagPolarityReversalParams
{
	DWORD 	dwBoardHandle; 		// Target Board 
	DWORD	dwLine;				// Target line 
	DWORD 	dwMode;
} PolarityReversalParams;

#define E1DialModeEnBlock		0	// By default, digit sent together in on time
#define E1DialModeOverlap		1	// Digit sent separately 

typedef struct _tagE1DialModeParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwDialMode;
} E1DialModeParams;

typedef struct _tagE1DigitsNumberParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwDigits;
} E1DigitsNumberParams;

#define E1MFREnable			0
#define E1DecadeEnable		1

typedef struct _tagE1MFRParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwEnable;			// MFR or Decade connection type on time slot
	DWORD dwToneDuration;
	DWORD dwPauseDuration;
} E1MFRParams;

typedef struct _tagE1OverlapTimeOutParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwTimeOut;
} E1OverlapTimeOutParams;

typedef struct _tagBoardProperties
{	
	DWORD	dwBusType;
	DWORD	dwBoardType;
	DWORD	dwBasePort;
	DWORD 	dwPciCtrlPort;
	DWORD	dwPciBus;
	BOOL	blSCBus;
	BOOL	blSCBusMaster;
	BOOL	blIrqMaster;
	DWORD	dwIrq;
	DWORD 	dwFactoryNumber;
	DWORD	dwLoaderVersion;
	DWORD	dwE1Lines;
	DWORD	dwE1MajorVersion;
	DWORD	dwE1MinorVersion;
	DWORD	dwE1STS;
	DWORD	dwResourceMode;
	DWORD	dwLines;
	DWORD	dwVoiceLines;
	BYTE	lpbLinesTypes[128];
	BYTE	lpbPossibleLinesTypes[128];
	DWORD	dwMaxConferenceCount;
	DWORD   dwMaxLineInConferences;
	DWORD	dwIsdnmLineAmount;
	DWORD	dwHardwareVersion;
	DWORD	dwReserved[28];
} BoardProperties;

typedef struct tagLineBreakParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwDetectionMode;
	DWORD dwDetectionLevel;
} LineBreakParams;

typedef struct tagDTMFDialLevel
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwLevel;
} DTMFDialLevel;

typedef struct tagPBXToneLevel
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwLevel;
} PBXToneLevel;

typedef struct tagToneLevel
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwLevel;
} ToneLevel;

typedef struct tagDTMFSensibility
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwSensibility;
} DTMFSensibility;

#define dwA14tFaxState		dwVoxCount

typedef struct _tagTH100BoardParameters
{
	DWORD dwBoardHandle;
	DWORD dwSynhroMode;			// 0= Slave, 1= Master
	DWORD dwTerminator;			// != 0 - H100 terminator ON
	DWORD lpdwReserved[61];
}TH100BoardParameters;

typedef struct _tagTH100CommutationParameters
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwLinkMode;			// != 0 - Link, = 0 - Unlink
	DWORD dwLineMode;			// != 0 - destinator, = 0 - sourcer
	DWORD dwH100Line;			// 0-31	
	DWORD dwH100TimeSlot;		// 0-127
	DWORD dwRecordMode;			// Record mode if 'dwLineMode' destinator. == 0 summ off, != 0 summ on
	DWORD lpdwReserved[58];
}TH100CommutationParameters;

typedef struct _tagTH100CommutationParameters TH100LineProperties;

typedef struct _tagTH100InterfaceProperties
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwMask;				//  0x1-EC, 0x2-DTMF, 0x4-ATE, 0x08 - LevelIndicator
	DWORD dwEcMode;				// != 0 - need EC, == 0 without EX
	DWORD dwDTMFDetector;		// != 0 - need DTMF detector
	DWORD dwATEDetector;		// != 0 - need ATE detector
	DWORD dwLevelIndicator;
	DWORD lpdwReserved[57];
}TH100InterfaceProperties;

typedef struct tagA9LineStatus
{	
	DWORD	dwChanged;
	DWORD	dwStatus;
	DWORD	dwLevel;
	DWORD	dwRecDeltaBuf;
	DWORD	dwPlayDeltaBuf;			
	DWORD	dwRawDeltaBuf;			
	DWORD	dwVoxCount;
	char    pszIncomingNum[32];    	
	char    pszIncomingQlt[16];
	char	pszUserID[32];		
	char	pszPulse[A9MaxDigitChars];
	char	pszTone[A9MaxDigitChars];
	char	chPulseNum;
	BYTE	bFill1[3];           	
	char	chToneNum;
	BYTE	bFill2[3];           	
} A9LineStatus;							

typedef A9LineStatus A14tLineStatus;
typedef A9LineStatus TLineStatus;

#pragma pack()

#ifndef WAV_HEADER
#define WAV_HEADER
#pragma pack(2)
typedef struct tagWAVEHEADER
{   BYTE 		lpbRiff[4];			// RIFF
	DWORD		dwRiffSize;			// sizeof(WAVHEADER)-8 + DataSize
	BYTE	   	lpbWave[4];			// WAVE
	BYTE	   	lpbFmt[4];			// FMT_
	DWORD		dwFmtSize;			// 20
		WORD		wFormatType;	//
		WORD		wChannels;		// ChannelsNum - always 1
		DWORD		dwFrequency;	// Always 8000
		DWORD		dwBps;        	//
		WORD 		wDataType;		//
		DWORD		dwWavMedia1;	// Unknown identifiner
		WORD		wWavMedia2;		// Unknown identifiner
		DWORD		dwSpeed;		// My compression ID
	BYTE		lpbFact[4];			// fact
	DWORD		dwFactSize;			// Always = 4;
		DWORD		dwAccount;		// Always = 0;
	BYTE		lpbData[4];			// Always= data
	DWORD		dwDataSize;       	// DataSize Count
}WAVEHEADER;
#pragma pack()
#endif

#pragma pack(4)
typedef struct _tagTLineToProcessData
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwMode;				// 0 - Link To Process, != 0 - unlink from Process
} TLineToProcessData;

typedef struct _tagTISDNMCommand
{
	DWORD dwBoardHandle;
	DWORD dwSizeInBytes;
	DWORD lpdwData[64];
} TISDNMCommand;

typedef struct _tagTE1Properties
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwManualAlerting;		// != 0 Driver do not sent ALERTING automatically
	DWORD dwQ931Monitoring;		// != 0 device sent to driver monitor device Q931 receipt
	DWORD dwQ921Monitoring;		// != 0 device sent to driver monitor device Q921 receipt
	DWORD dwProgressIndicator;	// != 0 Device sent PI after SETUP receive, 1 and 8 value recommended by Q.931
	DWORD dwVoiceClearMode;		// != 0 voice resource work without connection. Connection SM locked. 
								// TS link to voice resource directly.
	DWORD dwE1LineHaul;			// 0 - unknown, 1 - long (> 300 m), >=2 - short (< 300 m)(by default)
	DWORD dwTimeSlotMask;		// Mask for timeslot usability 0 or 0x3FFFFFFF - use all timeslots
	DWORD dwE1TraceMode;		// Internal use only.
	DWORD lpdwReserved[53];
} TE1Properties;

typedef struct _tagTE1LineProperties
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwMask;				// 0x1- consider field 'dwManualAlerting', 
								// 0x02- consider field 'dwProgressIndincator'
	DWORD dwManualAlerting;		// != 0 Driver do not sent ALERTING automatically
	DWORD dwProgressIndicator;	// != 0 Device sent PI after SETUP receive, 1 and 8 value recommended by Q.931
	DWORD lpdwReserved[59];
} TE1LineProperties;

typedef struct _tagTE1Restart
{
	DWORD dwMode;				// 0 - Restart for E1 line, != 0 Restart for E1 channel
	DWORD dwBoardHandle;
	DWORD dwE1Device;			// E1 device number
	DWORD dwE1Line;				// E1 Line number for Restart
	DWORD dwLine;				// Channel number for Restart
	DWORD lpdwReserved[60];
} TE1Restart;

typedef struct _tagTLineIdentData
{
	DWORD dwBoardHandle;
	DWORD dwLine;
} TLineIdentData;

typedef struct _tagTFXSParameters
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwHookUpDetectTime;		//     (150-5000 , 250   .,  10 )
	DWORD dwHookDownDetectTime;		//     (150-5000 , 500   .,  10 )
	DWORD dwFlashDetectTime;		//   FLASH (60-1000 , 100   .,  10 )
	DWORD dwPulseDurDetectTime;		//   . (20-250 , 50   .,  10 )
	DWORD dwPulsePauseDetectTime;	//   . (20-250 , 30   .,  10 )
	int iRxGainLevel;				//      . (-9dB..6dB, -7 dB  .,  1 dB)
	int iTxGainLevel;				//      . (-14dB..1dB, -1 dB  .,  1 dB)
	DWORD dwPowerLevel;				// 0 -   ( ), >0 -   ( )
	DWORD dwDTMFToneDuration;		//   DTMF( 40 - 0xFFFF , 80  -  )
	DWORD dwDTMFPauseDuration;		//     DTMF( 30 - 0xFFFF , 250  -  )
	DWORD dwReserved[28];			//   ,  
} TFXSParameters;

typedef struct _tagTFXOParameters
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwHookUpTimeForOutgoing;	//      . (150-5000 , 250   .,  10 )
	DWORD dwHookUpTimeForIncoming;	//      . (150-5000 , 500   .,  10 )
	DWORD dwHookDownTime;			//     (150-5000 , 800   .,  10 )
	DWORD dwPulseDurTime;			//   . (20-250 , 60   .,  10 )
	DWORD dwPulsePauseTime;			//   . (20-250 , 40   .,  10 )
	int iRxGainLevel;				//      . (-9dB..6dB, -7 dB  .,  1 dB)
	int iTxGainLevel;				//      . (-14dB..1dB, -1 dB  .,  1 dB)
	DWORD dwDTMFToneDuration;		//   DTMF( 40 - 0xFFFF , 80  -  )
	DWORD dwDTMFPauseDuration;		//     DTMF( 30 - 0xFFFF , 250  -  )
	DWORD dwRingFilterParam;		//       ( 40 - 2000,   - 200)
	DWORD dwReserved[28];			//   ,  
} TFXOParameters;
#pragma pack()

//     Disconnect
#define FAXMODEM_STATUS_RECEIVED_DCN						0
//    
#define FAXMODEM_STATUS_REQUEST_OPERATOR					1
//   
#define FAXMODEM_STATUS_NO_FAX_RESPONSE						2
//     
#define FAXMODEM_STATUS_FAR_SIDE_IS_RECEIVED				3
//    
#define FAXMODEM_STATUS_NOTHING_TO_SEND						4
//         
#define FAXMODEM_STATUS_ANSWER_IS_GONE						5
// Disconnect   T38
#define FAXMODEM_STATUS_T38_DCN								6
//     
#define FAXMODEM_STATUS_LAST_PAGE_SENT_ERROR				7
//    
#define FAXMODEM_STATUS_INVALID_PAGE_CONFIRM				8
//     
#define FAXMODEM_STATUS_NO_DIS_OR_DTC						9
//         
#define FAXMODEM_STATUS_FARSIDE_NOT_SUPPORT_OUR_MODES		10
//     
#define FAXMODEM_STATUS_RETRAIN_LIMIT						11
//     
#define FAXMODEM_STATUS_INVALID_ACK							12
//     
#define FAXMODEM_STATUS_INVALID_PAGE_ACK					13
//     
#define FAXMODEM_STATUS_NO_PAGE_ACK							14
//     
#define FAXMODEM_STATUS_PAGE_ACK_RECEIVED					15
//    V.21
#define FAXMODEM_STATUS_INVALID_V21							16
//   
#define FAXMODEM_STATUS_SENT_OK								17

#define FAXMODEM_STATUS_CANCELLED							117

#ifdef __cplusplus
}
#endif

#endif
